-- <?php exit;?>

DROP TABLE IF EXISTS `p8_ask_answer_`;
CREATE TABLE `p8_ask_answer_`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `tid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `username` char(30) NOT NULL DEFAULT '',
  `anonymous` tinyint(1) NOT NULL DEFAULT 0,
  `verify` tinyint(1) NOT NULL DEFAULT 1,
  `executor` tinyint(1) NOT NULL DEFAULT 0,
  `bestanswer` tinyint(1) NOT NULL DEFAULT 0,
  `vote_good` mediumint NOT NULL DEFAULT 0,
  `vote_bad` mediumint NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`),
  KEY `uid`(`uid`),
  KEY `verify`(`verify`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_answer_data`;
CREATE TABLE `p8_ask_answer_data`  (
  `id` int NOT NULL,
  `content` mediumtext NULL,
  PRIMARY KEY (`id`)
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_answer_follow`;
CREATE TABLE `p8_ask_answer_follow`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `tid` int NOT NULL DEFAULT 0,
  `aid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `reply_uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  `reply_time` int NOT NULL DEFAULT 0,
  `content` mediumtext NULL,
  `reply_content` mediumtext NULL,
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`),
  KEY `aid`(`aid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_answer_poller`;
CREATE TABLE `p8_ask_answer_poller`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `aid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `username` char(30) NOT NULL DEFAULT '',
  `anonymous` tinyint(1) NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  `addtime` int NOT NULL DEFAULT 0,
  `handler` tinyint(1) NOT NULL DEFAULT 0,
  `content` mediumtext NULL,
  PRIMARY KEY (`id`),
  KEY `aid`(`aid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_answer_votes`;
CREATE TABLE `p8_ask_answer_votes`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `aid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  `result` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `aid`(`aid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_attachment`;
CREATE TABLE `p8_ask_attachment`  (
  `id` int UNSIGNED NOT NULL AUTO_INCREMENT,
  `module` char(50) NOT NULL DEFAULT '',
  `item_id` int UNSIGNED NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `filename` char(100) NOT NULL DEFAULT '',
  `type` char(50) NOT NULL DEFAULT '',
  `ext` char(5) NOT NULL DEFAULT '',
  `size` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  `path` char(60) NOT NULL DEFAULT '',
  `thumb` tinyint(1) UNSIGNED NOT NULL DEFAULT 0,
  `remote` tinyint(1) UNSIGNED NOT NULL DEFAULT 0,
  `timestamp` int UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`, `uid`),
  KEY `module`(`module`, `timestamp`),
  KEY `uid`(`uid`, `timestamp`),
  KEY `item_id`(`item_id`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_category_`;
CREATE TABLE `p8_ask_category_`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` char(50) NOT NULL DEFAULT '',
  `parent` int NULL DEFAULT 0,
  `item_count` int NULL DEFAULT 0,
  `display` tinyint(1) NOT NULL DEFAULT 1,
  `display_order` mediumint NULL DEFAULT 0,
  `perpage` mediumint NOT NULL DEFAULT 0,
  `title_bytes` mediumint NOT NULL DEFAULT 0,
  `keywords` char(100) NOT NULL DEFAULT '',
  `description` char(200) NOT NULL DEFAULT '',
  `url` char(100) NOT NULL DEFAULT '',
  `list_template` char(50) NOT NULL DEFAULT '',
  `view_template` char(50) NOT NULL DEFAULT '',
  `block_template` char(50) NOT NULL DEFAULT '',
  `announce` mediumtext NULL,
  PRIMARY KEY (`id`),
  KEY `display_order`(`display_order`)
) ENGINE = MyISAM AUTO_INCREMENT = 74 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_expertors`;
CREATE TABLE `p8_ask_expertors`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `cid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cid`(`cid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_`;
CREATE TABLE `p8_ask_item_`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `cid` int NOT NULL DEFAULT 0,
  `title` char(80) NOT NULL DEFAULT '',
  `sub_title` char(80) NOT NULL DEFAULT '',
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `username` char(30) NOT NULL DEFAULT '',
  `to_uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `anonymous` tinyint NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  `offercredit` tinyint(1) NOT NULL DEFAULT 0,
  `credits` mediumint NOT NULL DEFAULT 0,
  `urgent` tinyint(1) NOT NULL DEFAULT 0,
  `province_id` mediumint NOT NULL DEFAULT 0,
  `city_id` mediumint NOT NULL DEFAULT 0,
  `views` int NOT NULL DEFAULT 0,
  `keywords` varchar(100) NOT NULL DEFAULT '',
  `replies` int NOT NULL DEFAULT 0,
  `lastpost` int NOT NULL DEFAULT 0,
  `lastpost_uid` mediumint NOT NULL DEFAULT 0,
  `lastposter` char(30) NOT NULL DEFAULT '',
  `endtime` int NOT NULL DEFAULT 0,
  `status` tinyint(1) NOT NULL DEFAULT 0,
  `solvetime` int NOT NULL DEFAULT 0,
  `verify` tinyint(1) NOT NULL DEFAULT 1,
  `closed` tinyint(1) NOT NULL DEFAULT 0,
  `recommend` tinyint(1) NOT NULL DEFAULT 0,
  `display_order` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `uid`(`uid`),
  KEY `to_uid`(`to_uid`),
  KEY `display_order`(`display_order`, `cid`, `lastpost`),
  KEY `verify`(`verify`, `urgent`, `closed`, `recommend`, `cid`, `province_id`, `city_id`, `addtime`, `lastpost`, `solvetime`)
) ENGINE = MyISAM AUTO_INCREMENT = 227 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_addition`;
CREATE TABLE `p8_ask_item_addition`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `tid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  `content` mediumtext NULL,
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_data`;
CREATE TABLE `p8_ask_item_data`  (
  `id` int NOT NULL DEFAULT 0,
  `tel` char(15) NOT NULL DEFAULT '',
  `info` char(32) NOT NULL DEFAULT '',
  `content` mediumtext NULL,
  `bestanswer` char(200) NOT NULL DEFAULT '',
  `bestanswer_id` int NOT NULL DEFAULT 0,
  `bestanswer_uid` int NOT NULL DEFAULT 0,
  `bestanswer_username` varchar(30) NOT NULL DEFAULT '',
  `bestanswer_time` int NOT NULL DEFAULT 0,
  KEY `id`(`id`)
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_favorites`;
CREATE TABLE `p8_ask_item_favorites`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `tid` int NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`),
  KEY `uid`(`uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_itemtags`;
CREATE TABLE `p8_ask_item_itemtags`  (
  `id` int NOT NULL DEFAULT 0,
  `tagname` char(30) NOT NULL DEFAULT '',
  KEY `id`(`id`)
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_poller`;
CREATE TABLE `p8_ask_item_poller`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `tid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `username` char(30) NOT NULL DEFAULT '',
  `anonymous` tinyint(1) NOT NULL DEFAULT 0,
  `ip` char(15) NOT NULL DEFAULT '',
  `addtime` int NOT NULL DEFAULT 0,
  `handler` tinyint(1) NOT NULL DEFAULT 0,
  `content` mediumtext NULL,
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_push`;
CREATE TABLE `p8_ask_item_push`  (
  `id` int NOT NULL AUTO_INCREMENT,
  `tid` int NOT NULL DEFAULT 0,
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `push_uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `addtime` int NOT NULL DEFAULT 0,
  `status` tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `tid`(`tid`),
  KEY `uid`(`uid`),
  KEY `push_uid`(`push_uid`)
) ENGINE = MyISAM AUTO_INCREMENT = 1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_tags`;
CREATE TABLE `p8_ask_item_tags`  (
  `tagname` char(30) NOT NULL DEFAULT '',
  `total` mediumint NOT NULL DEFAULT 0
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_item_unverified`;
CREATE TABLE `p8_ask_item_unverified`  (
  `id` int NOT NULL,
  `cid` int NOT NULL DEFAULT 0,
  `title` char(80) NOT NULL DEFAULT '',
  `uid` mediumint UNSIGNED NOT NULL DEFAULT 0,
  `username` char(30) NOT NULL DEFAULT '',
  `addtime` int NOT NULL DEFAULT 0,
  `views` int NOT NULL DEFAULT 0,
  `status` tinyint(1) NOT NULL DEFAULT 0,
  `verify` tinyint(1) NOT NULL DEFAULT 1,
  `closed` tinyint(1) NOT NULL DEFAULT 0,
  `recommend` tinyint(1) NOT NULL DEFAULT 0,
  `display_order` tinyint(1) NOT NULL DEFAULT 0,
  `urgent` tinyint(1) NOT NULL DEFAULT 0,
  `data` longtext NOT NULL,
  `push_back_reason` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cid`(`cid`, `addtime`)
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_member`;
CREATE TABLE `p8_ask_member`  (
  `id` mediumint UNSIGNED NOT NULL,
  `username` char(30) NOT NULL DEFAULT '',
  `role_id` tinyint NOT NULL DEFAULT 0,
  `verify` tinyint(1) NOT NULL DEFAULT 1,
  `expert` tinyint(1) NOT NULL DEFAULT 0,
  `star` tinyint(1) NOT NULL DEFAULT 0,
  `item_count` mediumint NULL DEFAULT 0,
  `solve_item_count` mediumint NULL DEFAULT 0,
  `reply_count` mediumint NULL DEFAULT 0,
  `fav_count` mediumint NULL DEFAULT 0,
  `last_ask_time` int UNSIGNED NOT NULL DEFAULT 0,
  `last_reply_time` int UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `role_id`(`role_id`),
  KEY `expert`(`expert`),
  KEY `star`(`star`)
) ENGINE = MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `p8_ask_statistics`;
CREATE TABLE `p8_ask_statistics`  (
  `item_count` int NULL DEFAULT 0,
  `solve_item_count` int NULL DEFAULT 0
) ENGINE = MyISAM DEFAULT CHARSET=utf8;


REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('1','政府公共','0','147','1','200','20','30','总裁办/行政','总裁办/行政','','list','view','default','关于本栏目，请大家讲具体问题提交，本栏目的管理员为部门经理及相应的工程师。同时欢迎大家都来回答与解答相应问题。');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('2','办事跟进','0','18','1','160','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('3','土地建筑','0','27','1','150','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('54','政府监督','2','0','1','157','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('7','政府合作','1','10','1','194','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('8',' 采购招标','1','5','1','196','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('9','政务公开咨询','1','55','1','198','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('10','群众困难','2','0','1','155','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('65','环境保护','46','1','1','136','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('64','生命财产','46','0','1','137','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('63','房屋安置拆迁','46','0','1','138','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('24','常规办事咨询','2','2','1','159','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('57','施工咨询','3','1','1','144','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('56','土地招标','3','8','1','146','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('55','常规交流咨询','3','16','1','148','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('46','法律咨询','0','1','1','140','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('45','行政服务','0','105','1','180','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('71','企业综合审批','45','9','1','178','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('72','企业纳税','45','2','1','176','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_category_` (`id`,`name`,`parent`,`item_count`,`display`,`display_order`,`perpage`,`title_bytes`,`keywords`,`description`,`url`,`list_template`,`view_template`,`block_template`,`announce`)VALUES('73','质检卫生','45','94','1','174','20','30','','','','list','view','default','');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('37','5','任何贴吧发帖都提示 您的帐号由于违规操作而被封','','1','admin','0','1','1282613118','218.107.20.105','0','0','0','0','0','118','','3','1282613118','0','','1314149118','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('35','12','哪些配置要换.换成什么比较好?','','1','admin','0','0','1282571695','58.62.156.55','0','0','0','0','0','80','','4','1282571695','0','','1314107695','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('34','8','php168V65什么时候正式发布','','1','admin','0','0','1282571630','59.33.165.212','1','5','0','0','0','164','','2','1282571630','0','','1314107630','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('36','33','处女座是什么演化而来的呢？有更详细的信息吗？','','1','admin','0','0','1282609784','58.62.156.55','1','30','1','0','0','88','','0','1282609784','0','','1314145784','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('32','12','集成显卡雷击了，我想换独立显卡，这样可以更换吗？','','1','admin','0','0','1282571422','58.62.156.55','0','0','0','0','0','79','','3','1282571422','0','','1314107422','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('31','12','为什么我电脑播放一个高清视频文件，cpu占用率就马上99%,点什么都卡','','1','admin','0','0','1282571274','58.62.156.55','1','30','0','0','0','86','','1','1282571274','0','','1314107274','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('7','33','泥石流是怎么造成的','','1','admin','0','0','1281329584','192.168.0.101','0','0','0','0','0','145','','2','1281329584','0','','1281934384','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('30','12','内存2G显卡GT220CPUE5200这样的配置能在最低特效下运行GTA4和孤岛危机吗','','1','admin','0','0','1282571135','58.62.156.55','0','0','0','0','0','79','','2','1282571135','0','','1314107135','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('29','10','液晶显示器对眼睛有害吗？','','1','admin','0','0','1282570606','58.62.156.55','1','20','1','0','0','116','','0','1282570606','0','','1314106606','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('50','6','电脑重装系统问题','','1','admin','0','0','1282616628','218.107.20.105','0','0','1','0','0','79','','1','1282616628','0','','1314152628','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('49','6','XP系统安装问题','','1','admin','0','0','1282615836','218.107.20.105','0','0','1','0','0','90','','5','1282615836','0','','1314151836','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('28','11','液晶的显示器有辐射吗?','','1','admin','0','0','1282570236','58.62.156.55','1','15','0','0','0','107','','5','1282570236','0','','1314106236','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('44','8','电脑有时候打字只能用五笔。按shift和ctrl都是五笔。','','1','admin','0','0','1282614205','218.107.20.105','1','10','1','0','0','146','','3','1282614205','0','','1314150205','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('45','9','求有什么好方法使我一个月掌握和操作PS呢？','','1','admin','0','0','1282615165','218.107.20.105','0','0','0','0','0','137','','1','1282615165','0','','1314151165','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('27','10','怎样解决硬盘不能下载5G文件的问题','','1','admin','0','0','1282553472','218.107.20.105','0','0','0','0','0','105','','1','1282553472','0','','1314089472','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('46','6','V6.5整站套件安装过程中出现数据库连接错误如何解决？','','1','admin','0','0','1282615332','218.107.20.105','1','10','1','0','0','78','','0','1282615332','0','','1314151332','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('47','6','V6.5的套件最新下载地址是什么？','','1','admin','0','0','1282615521','218.107.20.105','0','0','0','0','0','79','','1','1282615521','0','','1314151521','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('48','6','PHP168的套件安装问题','','1','admin','0','0','1282615717','218.107.20.105','0','0','1','0','0','80','','1','1282615717','0','','1314151717','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('39','6','当硬盘满时电驴会把文件下载到哪里?','','1','admin','0','0','1282613585','218.107.20.105','0','0','0','0','0','94','','3','1282613585','0','','1314149585','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('20','9','PHP168开源平台的优势有哪些','','1','admin','0','1','1281492144','192.168.0.109','0','0','0','0','0','263','','2','1281492144','0','','1313028144','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('38','8','请问我的帐号给人盗号了！验证信息给修改了！我能拿回来来吗？','','1','admin','0','0','1282613288','218.107.20.105','0','0','1','0','0','157','','3','1282613288','0','','1314149288','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('26','10','电脑清扫灰尘后不能开机，没有报警声。','','1','admin','0','0','1282552227','218.107.20.105','1','10','1','0','0','160','','3','1282552227','0','','1314088227','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('24','14','win7中毒，很多程序点击都是弹出一个系统播放器','','1','admin','0','0','1282551228','218.107.20.105','1','5','0','0','0','161','','5','1282551228','0','','1314087228','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('51','6','高分求解（系统安装问题）','','1','admin','0','0','1282616750','218.107.20.105','1','15','1','0','0','68','','0','1282616750','0','','1314152750','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('52','6','安装XP系统的问题','','1','admin','0','0','1282616881','218.107.20.105','0','0','1','0','0','74','','0','1282616881','0','','1314152881','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('53','6','zend studio工具不会用','','1','admin','0','0','1282616926','218.107.20.105','0','0','0','0','0','76','','1','1282616926','0','','1314152926','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('54','6','PHP168安装急问题','','1','admin','0','0','1282617026','218.107.20.105','0','0','1','0','0','79','','0','1282617026','0','','1314153026','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('55','9','官方能否考虑开发转换程序？','','1','admin','0','1','1282617122','218.107.20.105','0','0','0','0','0','134','','2','1282617122','0','','1314153122','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('56','8','P8的测试版本可以升级到正式版的吗','','1','admin','0','1','1282617152','218.107.20.105','0','0','0','0','0','143','','1','1282617152','0','','1314153152','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('57','6','PHP环境下安装一个PHP168整站时出现的问题,请达人帮忙啊!~~~解决了再多赠送！','','1','admin','0','0','1282617273','218.107.20.105','0','0','0','0','0','86','','2','1282617273','0','','1314153273','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('58','6','php168做首页的问题，10分悬赏，请高手作答，有追加分 在线等','','1','admin','0','0','1282617334','218.107.20.105','1','10','1','0','0','82','','0','1282617334','0','','1314153334','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('59','6','整合php168同步登陆的问题','','1','admin','0','0','1282617410','218.107.20.105','0','0','1','0','0','76','','0','1282617410','0','','1314153410','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('60','9','对官方btob系统的一些建设性建议？','','1','admin','0','1','1282617605','218.107.20.105','0','0','0','0','0','163','','1','1282617605','0','','1314153605','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('61','6','在LP安装PHP168出错，急急......','','1','admin','0','0','1282617615','218.107.20.105','1','5','1','0','0','94','','1','1282617615','0','','1314153615','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('63','5','PHP168问答系统 公测版 大约什么时候发布？','','1','admin','0','0','1282617913','218.107.20.105','0','0','0','0','0','96','','1','1282617913','0','','1314153913','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('64','8','你是超级管理员吗？','','1','admin','1','0','1282618547','218.107.20.105','0','0','0','0','0','165','','1','1282618547','0','','1314154547','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('65','5','知道系统里的专家要怎么申请？','','1','admin','0','0','1282618777','218.107.20.105','0','0','1','0','0','76','','0','1282618777','0','','1314154777','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('66','7','建议p8在v65稳定后举行一次模板制作大赛！','','1','admin','0','1','1282619887','218.107.20.105','0','0','0','0','0','131','','1','1282619887','0','','1314155887','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('67','9','建议分类信息系统增加商家店铺栏目','','1','admin','0','1','1282620046','218.107.20.105','0','0','0','0','0','134','','1','1282620046','0','','1314156046','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('68','9','手机网民超过电脑上网网民，P8的WAP在开发吗？','','1','admin','0','0','1282620140','218.107.20.105','1','5','1','0','0','142','','2','1282620140','0','','1314156140','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('69','5','哪有好的仿百度知道的问答系统啊','','1','admin','0','0','1282620151','218.107.20.105','0','0','0','0','0','82','','2','1282620151','0','','1314156151','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('70','8','用开源代码做个地方门户站用付费么?','','1','admin','0','0','1282620185','218.107.20.105','0','0','1','0','0','155','','1','1282620185','0','','1314156185','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('71','6','请问php168是什么数据库类型','','1','admin','0','0','1282620312','218.107.20.105','0','0','0','0','0','74','','2','1282620312','0','','1314156312','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('72','9','建议开发一键更新发表文章时间的功能','','1','admin','0','0','1282620423','218.107.20.105','0','0','0','0','0','141','','2','1282620423','0','','1314156423','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('73','5','问答系统里的积分有什么作用？','','1','admin','0','0','1282620475','218.107.20.105','0','0','0','0','0','90','','2','1282620475','0','','1314156475','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('74','8','关于v6.5保持网站整洁性防止垃圾产生的建议','','1','admin','0','0','1282620522','218.107.20.105','0','0','0','0','0','143','','1','1282620522','0','','1314156522','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('75','5','问答网站的如何推广？','','1','admin','0','0','1282620590','218.107.20.105','0','0','1','0','0','76','','1','1282620590','0','','1314156590','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('76','9','建议官方增加文章栏目等可选择增加更多按钮','','1','admin','0','0','1282620652','218.107.20.105','0','0','0','0','0','132','','1','1282620652','0','','1314156652','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('77','5','V6.5的正式版包含了问答系统吗？是免费的吗？','','1','admin','0','0','1282620700','218.107.20.105','0','0','0','0','0','84','','3','1282620700','0','','1314156700','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('78','8','请问商业版v6购买后的服务','','1','admin','0','0','1282620769','218.107.20.105','0','0','0','0','0','158','','1','1282620769','0','','1314156769','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('79','13','如何把握电子商务发展中的致富机遇','','1','admin','0','0','1282620844','218.107.20.105','0','0','0','0','0','84','','0','1282620844','0','','1314156844','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('80','5','V6.5的问答系统可以支持伪静态吗？','','1','admin','0','0','1282620852','218.107.20.105','0','0','0','0','0','82','','2','1282620852','0','','1314156852','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('81','5','有没有独立的问答系统下载？','','1','admin','0','0','1282620989','218.107.20.105','0','0','0','0','0','81','','2','1282620989','0','','1314156989','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('82','9','全力等6.5标准版。放出之前没事可做了','','1','admin','0','0','1282621063','218.107.20.105','0','0','1','0','0','221','','2','1282621063','0','','1314157063','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('83','5','想做一个小型的问答系统！','','1','admin','0','0','1282621409','218.107.20.105','0','0','0','0','0','80','','1','1282621409','0','','1314157409','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('84','9','关于保留部分后台登陆操作日志的建议','','1','admin','0','0','1282621481','218.107.20.105','0','0','0','0','0','146','','1','1282621481','0','','1314157481','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('85','5','请问官方问答系统是否支持ucenter，而且可以独立使用？','','1','admin','0','0','1282621671','218.107.20.105','0','0','1','0','0','93','','1','1282621671','0','','1314157671','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('87','9','建议P8的会员中心菜单设置中多加个显示或隐藏功能','','1','admin','0','0','1282631384','58.248.196.58','0','0','1','0','0','148','','1','1282631384','0','','1314167384','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('88','9','突然想到一种新的内容防止复制的方法 绝对高明','','1','admin','0','0','1282631625','58.248.196.58','0','0','0','0','0','142','','2','1282631625','0','','1314167625','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('89','8','文章先写好，设置到时自动发布6.5能实现吗','','1','admin','0','0','1282632875','58.248.196.58','0','0','0','0','0','177','','1','1282632875','0','','1314168875','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('91','7','还没有做PHP168 S系统的风格吗？','','1','admin','0','0','1282634430','58.248.196.58','0','0','1','0','0','150','','1','1282634430','0','','1314170430','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('92','7','保存的网页乱七八糟的，如何解决？','','1','admin','0','0','1282634619','58.248.196.58','1','30','1','0','0','136','','2','1282634619','0','','1314170619','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('93','7','仿了个风格搜索页面不居中？怎么办啊','','1','admin','0','1','1282634932','58.248.196.58','0','0','0','0','0','123','','1','1282634932','0','','1314170932','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('94','7','我自己仿的模板为什么首页是空白的呢？','','1','admin','0','0','1282635106','58.248.196.58','1','10','0','0','0','132','','1','1282635106','0','','1314171106','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('95','24','有什么好的地区门户网站麽？有的把地址贴出来','','1','admin','0','0','1282635151','58.248.196.58','0','0','0','0','0','92','','0','1282635151','0','','1314171151','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('96','7','谁知道如何在网站后台添加 雅黑字体？','','1','admin','0','0','1282635243','58.248.196.58','0','0','1','0','0','137','','3','1282635243','0','','1314171243','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('97','7','下拉菜单的样式怎么修改呢, 在哪修改？','','1','admin','0','0','1282635570','58.248.196.58','0','0','1','0','0','145','','1','1282635570','0','','1314171570','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('98','7','其他设置中的滚动代码怎么改动？','','1','admin','0','0','1282635763','58.248.196.58','0','0','0','0','0','121','','1','1282635763','0','','1314171763','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('99','7','为什么网站风格在百度快照里面变形？','','1','admin','0','0','1282635826','58.248.196.58','0','0','0','0','0','133','','2','1282635826','0','','1314171826','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('100','7','内容页模板在哪里设置啊？或者说在哪儿啊？','','1','admin','0','1','1282636383','58.248.196.58','0','0','0','0','0','138','','1','1282636383','0','','1314172383','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('101','7','如何在大分类页加个分页功能？','','1','admin','0','0','1282636778','58.248.196.58','0','0','1','0','0','126','','1','1282636778','0','','1314172778','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('102','7','请问商城图片大小如何修改？','','1','admin','0','0','1282636851','58.248.196.58','1','15','0','0','0','130','','1','1282636851','0','','1314172851','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('104','7','模板安装后怎么设置生效呢？','','1','admin','0','1','1282637109','58.248.196.58','0','0','1','0','0','138','','1','1282637109','0','','1314173109','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('105','7','V6.01版本的更新缓存的具体位置在哪？','','1','admin','0','1','1282637494','58.248.196.58','0','0','0','0','0','183','','1','1282637494','0','','1314173494','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('106','7','内容页中字体大小变化和繁简字转换失灵','','1','admin','0','0','1282637611','58.248.196.58','0','0','1','0','0','214','','1','1282637611','0','','1314173611','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('107','8','问高手，会员管理里面，如何查看会员的登录密码？','','1','admin','0','0','1282637829','58.248.196.58','0','0','0','0','0','166','','1','1282637829','0','','1314173829','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('108','8','安装p8后，ICP备案号安装在哪个地方？','','1','admin','0','0','1282637962','58.248.196.58','0','0','1','0','0','189','','1','1282637962','0','','1314173962','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('109','8','会员注册要通过审核在哪里设置了？','','1','admin','0','0','1282638043','58.248.196.58','0','0','0','0','0','156','','1','1282638043','0','','1314174043','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('110','8','怎样使“评论审核”只针对普通会员？','','1','admin','0','0','1282638128','58.248.196.58','0','0','0','0','0','154','','1','1282638128','0','','1314174128','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('111','8','采集入库图片提示图片格式不允许怎么办？','','1','admin','0','0','1282638224','58.248.196.58','1','10','0','0','0','168','','1','1282638224','0','','1314174224','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('112','8','使用P8，如何更改怎样修改超级管理员账号名？','','1','admin','0','0','1282638288','58.248.196.58','0','0','0','0','0','231','','1','1282638288','0','','1314174288','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('113','9','意见征集：关于V6.5架构采用全新sharp(锐利、锐不可挡之意)命名的意见调查','','1','admin','0','0','1282641980','58.248.196.58','1','30','0','0','0','222','','4','1282641980','0','','1314177980','3','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('114','9','二次开发和插件区怎么要求这么高啊？','','1','admin','0','1','1282642629','58.248.196.58','0','0','0','0','0','176','','2','1282642629','0','','1314178629','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('115','5','知道系统的运用有哪些?','','1','admin','0','0','1282642933','58.248.196.58','0','0','0','0','0','87','','0','1282642933','0','','1314178933','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('116','5','好用的知道系统有哪些？','','1','admin','0','0','1282643057','58.248.196.58','0','0','0','0','0','86','','0','1282643057','0','','1314179057','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('117','5','地方门户系统可以整合知道系统吗？','','1','admin','0','0','1282643468','58.248.196.58','0','0','0','0','0','80','','1','1282643468','0','','1314179468','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('118','6','购买授权后包括系统安装吗？','','1','admin','0','0','1282643560','58.248.196.58','0','0','0','0','0','150','','3','1282643560','0','','1314179560','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('119','5','有知道系统的案例吗？发一个看看','','1','admin','0','0','1282644287','58.248.196.58','0','0','0','0','0','137','','1','1282644287','0','','1314180287','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('120','5','问答系统里如何向专家提问？','','1','admin','0','0','1282644547','58.248.196.58','0','0','0','0','0','87','','0','1282644547','0','','1314180547','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('122','24','我想建个医学站，有没有人帮做模板？','','1','admin','0','0','1282745371','122.225.3.5','0','0','0','0','0','146','','0','1282745371','0','','1314281371','1','0','1','0','1','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('123','8','是一下，看看怎么样','','1','admin','0','0','1282751567','123.116.36.145','1','5','0','0','0','152','','0','1282751567','0','','1314287567','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('124','8','V65发布时间','','1','admin','1','0','1282751653','123.116.36.145','0','0','0','0','0','168','','0','1282751653','0','','1314287653','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('125','9','问答系统功能介绍？请官方介绍下','','1','admin','0','0','1282752670','121.33.32.17','0','0','0','0','0','165','','1','1282752670','0','','1314288670','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('126','9','6.5系统为什么要改名为Sharp？','','1','admin','0','0','1282790891','58.248.196.58','0','0','0','0','0','227','','5','1282790891','0','','1314326891','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('127','8','今天6.5正式版发布，大概是什么时候？','','1','admin','0','0','1282790961','58.248.196.58','0','0','0','0','0','164','','0','1282790961','0','','1314326961','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('128','8','请问商业版v6购买后的服务？','','1','admin','0','0','1282791086','58.248.196.58','0','0','0','0','0','141','','0','1282791086','0','','1314327086','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('129','7','有没有做PHP168 S系统的风格吗？','','1','admin','0','0','1282791173','58.248.196.58','0','0','0','0','0','138','','0','1282791173','0','','1314327173','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('130','6','V6.5的套件最新下载地址是什么？','','1','admin','0','0','1282791232','58.248.196.58','0','0','0','0','0','106','','0','1282791232','0','','1314327232','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('131','6','V6.5套件安装过程中出现数据库连接错误如何解决？','','1','admin','0','0','1282791349','58.248.196.58','0','0','0','0','0','98','','0','1282791349','0','','1314327349','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('132','8','P8的地方门户站用付费么?','','1','admin','0','0','1282791441','58.248.196.58','0','0','0','0','0','197','','0','1282791441','0','','1314327441','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('133','12','怎么设置前台权限？','','1','admin','0','0','1282792826','58.248.196.58','0','0','0','0','0','131','','0','1282792826','0','','1314328826','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('134','8','而然太热特瑞特尔问题','','1','admin','0','0','1295926105','192.168.1.110','0','0','0','0','0','239','','0','1295926105','0','','1298518105','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('135','9','新的1年，我们要提问了。','','1','admin','0','0','1297646813','219.136.200.207','0','0','0','0','0','235','','1','1297646813','0','','1300238813','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('136','9','请问达人，采购的发票如果过去了，怎么搞？','','1','admin','0','0','1297647385','219.136.200.207','0','0','0','0','0','253','','1','1297647385','0','','1300239385','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('139','9','nsdfsdfdfsdfsdfsd','','1','admin','0','0','1297822208','219.136.141.114','0','0','0','0','0','217','','1','1297822208','0','','1300414208','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('144','9','你好，我要如何购买系统','','1','admin','0','0','1297836016','219.136.141.114','0','0','0','0','0','254','','1','1297836016','0','','1300428016','3','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('145','9','sdfsdfsdfds','','1','admin','0','0','1297999308','219.136.141.114','0','0','0','0','0','237','','0','1297999308','0','','1300591308','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('218','92','sdfsdfdsfdsfsfdsafsfdsfds','','1','admin','0','0','1302493682','219.135.161.85','0','0','0','0','0','171','','0','1302493682','0','','1305085682','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('221','89','咨询下提案方面的流程','','1','admin','0','0','1307524747','219.136.138.145','0','0','0','0','0','184','','1','1307524747','0','','1310116747','1','0','1','0','0','0');
REPLACE INTO `p8_ask_item_` (`id`,`cid`,`title`,`sub_title`,`uid`,`username`,`to_uid`,`anonymous`,`addtime`,`ip`,`offercredit`,`credits`,`urgent`,`province_id`,`city_id`,`views`,`keywords`,`replies`,`lastpost`,`lastpost_uid`,`lastposter`,`endtime`,`status`,`solvetime`,`verify`,`closed`,`recommend`,`display_order`)VALUES('226','9','发的上的风格飞','','0','','0','1','1384835987','222.212.180.123','1','5','0','0','0','1','','0','1384835987','0','','1387427987','1','0','0','0','0','0');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('15','32','4','1282571445','补充一下，我打错字了  是网卡。

集成网卡想换独立网卡，请问具体步骤');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('12','26','6','1282552242','就是拨了内存也不报警才不知道怎么搞了 
显卡也试了，还是没有反应');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('13','29','4','1282570898','由于液晶显示器的技术特殊性，人们大多数认为液晶显示器是一种对视力有保护作用的产品。那么，实际情况是这样的吗？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('14','30','4','1282571234','这样的配置能玩大型的网络游戏吗？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('10','24','8','1282551536','不是很想重装系统，没有备份文件，求高手.... ');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('11','24','8','1282551565','进去安全模式，（开机按住F8键）再调用杀软全盘查杀！ ');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('18','28','4','1282573221','孕妇可不可以用？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('17','35','1','1282571743','光驱:东芝-三星 DVD-ROM  TS-H352C DVD光驱
声卡:Analong Devices AD1986 @ 威胜 VT1709/A 高保真音频
网卡:博通BCM400x 100Bese-TX Fast  Ethernet/联想');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('19','36','8','1282610199','神话传说：处女座是正义女神阿斯特里亚的象征。在黄金年代末期，人类互相残杀，神灵们都放弃人类回到了%');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('20','44','18','1282614298','我装了多种输入法的，切换不了');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('21','46','20','1282615372','数据库的表名是什么意思？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('22','47','20','1282615571','我记得上次在论坛哪个帖子里见过');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('23','50','20','1282616679','可以用GHOST吗？怎么用？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('24','69','23','1282620164','我想要程序哦');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('25','72','5','1282620453','希望被采纳引用，大家共享。呵呵');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('26','75','23','1282620616','不知道39健康的问答网站是怎么推广的');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('27','79','5','1282620886','时代的趋势下潜藏着巨大的商机，不同于80年代只要下海便能赚钱，90年代入市就能炒金，电子商务带来的商机是更加巨大，以及更加持久的。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('28','79','5','1282620907','阿里巴巴说，要让天下没有难做的生意，所以他们竭力打造电子商务中的诚信体系，我们应该看到，这是为了下一步电子商务腾飞做出的铺垫。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('29','73','23','1282622613','我发现这个问题很菜，呵呵');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('30','87','22','1282631520','发表内容已经有了，就是不知道有权限的显示与隐藏代码如何写');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('31','91','22','1282634491','官方出个教程吧，我天天在等呢，8月份出来吧？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('32','92','22','1282634684','本人菜鸟一个，期望大家指点一二。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('33','97','26','1282635623','小弟刚开始学习使用，希望大家指点，谢谢！');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('34','97','26','1282635666','刚才在论坛里面搜索一下，没有发现现成的答案，再次救助。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('35','99','26','1282635858','有些人说很正常的,百度快照调用CSS不正常。大部分快照都这样，是真的吗？');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('36','107','4','1282637894','是不是管理员也没办法看到密码呢');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('37','125','37','1282752692','最好是有白皮书');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('38','125','37','1282752745','如果能有演示站，并有图片的话，那就更明了了。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('39','135','1','1297646839','我来看看大家如何了');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('40','139','1','1297822309','sdfsdfdfsdfsdfds');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('55','158','3','1300270701','撒地方说道士大夫士大夫地方时');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('54','158','3','1300270695','是对方说道士大夫');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('45','144','1','1297836036','五二五忍忍地方改单费个');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('46','144','1','1297836044','撒打发撒打发发的是否当时敌陕郛撒打发');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('47','145','1','1297999321','sdfdfdsfsdafsdfsdfsdfsdf');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('48','145','1','1297999329','sdfdfsdfsdfsdfdfsd');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('56','158','3','1300270710','士大夫士大夫士大夫但是第三方第三方');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('66','170','8','1300608071','我再补充下，任何时候都可以修改。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('67','170','8','1300608092','前面我估计没有说清楚，现在我想说，有链接，请查看。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('68','170','8','1300608164','我想说，这个问题系统太棒了。');
REPLACE INTO `p8_ask_item_addition` (`id`,`tid`,`uid`,`addtime`,`content`)VALUES('102','134','1','1345939728',' 2342');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('46','','','<p>\r\n	V6.5整站套件安装过程中出现数据库连接错误，是不是我的数据库资料填写错误了？</p>\r\n<p>\r\n	数据库名是不是可以任意填写？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('45','','','<p>\r\n	自己现在会一点PS 但是肯定是学习方法有错 记不住东西 求有什么好方法使我一个月掌握和操作PS呢？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('44','','','<p>\r\n	电脑有时候打字只能用五笔。按shift和ctrl都是五笔。 再看右下角。 语言栏没看到了。 怎样解决这类的问题</p>\r\n','46 控制面板——区域和语言选项——语言——详细信息。\r\n在“已安装... 1282614478 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('51','','','<p>\r\n	问题：Windows2003的安装源文件在移动硬盘的任何一个分区（假设H盘），当计算机在启动时，怎么让计算机能自动的启动移动硬盘的指定分区(比如H盘)，从而读取H盘中安装文件，实现像从光盘启动安装操作系统是一样。<br />\r\n	概括成一句话&ldquo;单从安装系统的角度来看，我要用移动硬盘代替光驱&rdquo;<br />\r\n	注意事项：<br />\r\n	1、我不是不知道怎么安装系统，因为要安装系统的方法有很多，所以别说通过什么PE之类的。<br />\r\n	2、我的提问肯定是有解的，因为安装windows 7时，我就只是做了二步就成功的实现了，<br />\r\n	1）、把移动硬盘的H盘设置成&ldquo;将磁盘分区标为活动的&rdquo;，并把windows 7的安装文件全部拷到H盘的根目录下<br />\r\n	这样当重启计算机时就能读取H盘下的安装文件，跟用光驱安装系统是一模一样的。<br />\r\n	谢谢各位回答！</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('50','','','<p>\r\n	我想重新装下系统,但又不懂,现在想学一下,哪个高手能教一把,就是重起机子后,要怎么操作</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('47','','','<p>\r\n	RT，我在论坛找了好久没有找到。呵呵</p>\r\n','131 在官方的首页有一个下载区，找6.0的套件是一样的啊，6.5的套件只... 1282712391 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('48','','','<p>\r\n	我弱弱的问一句，php168的套件是不是只能装在本地的D盘？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('49','','','<p>\r\n	小弟我先安的XP.<br />\r\n	在不删除XP的情况下.<br />\r\n	再安装98或者2003有问题嘛</p>\r\n','49 想说一下\r\n安装系统是完全不需要顺序的\r\n你可以先装Linux，再装X... 1282615904 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('38','','','<p>\r\n	请问我的帐号给人盗号了！验证信息给修改了！我能拿回来来吗？怎么操作？我是玩玩的！</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('39','','','<p>\r\n	当硬盘满时电驴会把文件下载到哪里?</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('37','','','<p>\r\n	id被封 任何贴吧发帖都提示 您的帐号由于违规操作而被封，目前无权限进行该操作。</p>\r\n','39 你好，系统机器人封禁一般是三天就会自动解封，也有的会持续三个... 1282613181 8 viqtok','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('7','','','<p>\r\n	泥石流是怎么造成的</p>\r\n','5 泥石流的形成必须同时具备以下3个条件：陡峻的便于集水、集物的地... 1281329673 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('36','','','<p>\r\n	<img alt=\"9304c888cce725a6a5c2722f.jpg\" src=\"http://v65.php168.com/attachment/ask/item/2010_08/24_08/91b0ff40030d680f.jpg\" style=\"width: 200px; height: 141px;\" />处女座（virgo）8月23日到9月22日，天文学上位于赤经13时20分，赤纬－5度。在狮子座之东，平秤座之西。&alpha;星（角宿一）是1等星。处女座是六月下旬的黄昏时刻，在南方天空可看见它，其中特别明亮的就是一等星的斯比卡。黄道第六个星座是处女座，其象徵图形是一名手持麦穗的少女，是以许多大小不同的星星而构成为天使似的少女模样,意味著处女座的独立自主。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('34','','','<p>\r\n	php168V65什么时候正式发布<span bookmark=\"1\" style=\"display: none\">&nbsp;</span>，期待。。</p>\r\n','29 据说本周四会正式发布媒体版本哦。\r\n引用http://www.php168.net 1282573288 4 hjiash','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('35','','','<p>\r\n	处理器:AMD Sempron闪龙3200+&nbsp; 主板:OEM 主板 (威胜 K8M89OCE 内存:512MB (记忆科技 DDR2 553MHz)<br />\r\n	主硬盘:西数 WDC WD800BD-08MA1&nbsp; (80GB) 显卡:威胜K8M890CE/K8N89OCE(Chrome 9)(64MB)</p>\r\n','36 别那么急着换显卡，先看你的电源能不能带动。你这是品牌机的话电... 1282608767 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('27','','','<p>\r\n	怎样解决硬盘不能下载5G文件的问题</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('28','','','<p>\r\n	液晶的显示器有辐射吗?</p>\r\n','27 液晶显示器与CRT显示器相比，可谓是春兰秋菊，各有胜场。传统的C... 1282573056 5 foxcn','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('29','','','<p>\r\n	夜晶显示器对眼睛有害吗？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('30','','','<p>\r\n	内存2G显卡GT220CPUE5200这样的配置能在最低特效下运行GTA4和孤岛危机吗</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('31','','','<p>\r\n	为什么我电脑播放一个高清视频文件，cpu占用率就马上99%,点什么都卡，真郁闷了。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('32','','','<p>\r\n	集成显卡雷击了，我想换独立显卡，这样可以更换吗？需要在电脑上怎么操作？我是电脑盲请将步骤写的详细些，谢谢！</p>\r\n','25 如果集成显卡遭雷击了，八成你那主板也over了，就别指望再买个独... 1282572912 3 shine','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('20','','','<p>\r\n	大家可以多体验PHP168&nbsp; V6.5的各类优势情况，欢迎大家体验并提交建议。</p>\r\n','9 看看具体情况 1281493004 10 liuxiaojun','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('26','','','<p>\r\n	电脑清扫灰尘后不能开机，没有报警声。 主要清扫的CPU和显卡，在清扫前没有问题。CPU风扇在转，显卡风扇在转，拆了内存后没有报警声</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('24','','','<p>\r\n	win7中毒，很多程序点击都是弹出一个系统播放器，杀毒软件都打不开，但点击属性查看时，目标路径没有被改</p>\r\n','13 1.百度搜索【金山顽固木马专杀】,下载第一个连接下载,\r\n2.下载回... 1282551602 1 admin','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('52','','','<p>\r\n	最好是能多介绍几种系统安装方法，呵呵，谢谢各位的回答！</p>\r\n<p>\r\n	比如：DOS下怎么用GHOST</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('53','','','<p>\r\n	zend studio for eclipse 安装完了&nbsp; 也安装了wamp 我想运行调试下php项目。不知道应该怎么弄&nbsp;&nbsp;&nbsp;&nbsp; 哪位好心人教教我哇</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('54','','','<p>\r\n	安装的时候初始界面填写所在数据库怎么填写啊！安装的时候需要填数据库帐户密码和主机IP。那个所在数据库是什么意思。怎么填</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('55','','','<div class=\"f14\" id=\"read_tpc\">\r\n	现在V65程序基本上都已经开发完毕了，我想很多站长以前是用其他CMS程序的，也有很多想要用P8程序，但又舍不得原来网站的数据，官方能不能出几个主流CMS转换到P8的程序呢？</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('56','','','<p>\r\n	<span id=\"subject_tpc\">P8的测试版本可以升级到正式版的吗</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('57','','','<p>\r\n	PHP环境:系统:Windows xp<br />\r\n	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; WEB 服务器:Apache 2.2<br />\r\n	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 数据库:Mysql 5.0<br />\r\n	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; zend优化:zend optimizer-3.3.0<br />\r\n	PHP环境搭建好后,网页显示正常,Zend optimizer正常,进入mysql也正常,我的问题出在哪儿了？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('58','','','<p>\r\n	要用php168v6的模板，首页怎么显示一个列表出全站最新加入的内容（5个）的模板。有下载类型，有文章类型，视频类型等，怎么做<br />\r\n	我是菜鸟，请高手帮忙，越详细越好，在线等</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('59','','','<p>\r\n	uch和bbs可以同步登陆，安装php168时直接整合dz7，安装成功，在php168后台进行相关设置，在uc里添加自定义应用，显示通信失败，php168和dz7实现同步登陆，但是登陆后php168的登陆条不见了！！<br />\r\n	<br />\r\n	先登录bbs和php168后打开uch，uch未登录！！也无法同步退出。<br />\r\n	<br />\r\n	先登录uch后打开bbs和php168，均能登陆。也能同步退出。<br />\r\n	<br />\r\n	这样的问题如何解决？谢谢！！</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('60','','','<p>\r\n	首先提议官方开辟一个单独的版块讨论商务系统，既然是官方的重点产品，单独的讨论版块都没有，有些迷糊。现在官方的思路还是N年前的老思路，供求，供求。而已。当然不是说供求不需要，但应该看到更长远的东西，现在的企业不会满足于发布一些信息而已，至于信息发布之后取得的效益是他们更加关注的。因为现在提供发布信息的地方太多太多，所有这点已经吸引不了他们了。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('61','','','<p>\r\n	有谁在LP成功安装了PHP168吗？<br />\r\n	我今天在LP安装和运行了PHP168程序，但出现错误提示，如下：<br />\r\n	<br />\r\n	Internal Server Error<br />\r\n	The server encountered an internal error or misconfiguration and was unable to complete your request.<br />\r\n	<br />\r\n	Additionally, a 404 Not Found error was encountered while trying to use an ErrorDocument to handle the request.<br />\r\n	<br />\r\n	这是那里出错呢。是不是php.in文件要修改还是那里有问题？<br />\r\n	&nbsp;</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('63','','','<p>\r\n	RT，PHP168问答系统公测版什么时候发布啊，等着用呢，呵呵</p>\r\n','56 官方在论坛发表的测试版里不是有问答系统吗？呵呵 1282621761 20 skyboy','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('64','','','<p>\r\n	你是超级管理员吗？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('65','','','<p>\r\n	知道系统里的专家要怎么申请？我想成为专家，不知道需要什么要求，怎么申请？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('66','','','<p>\r\n	建议p8在v65稳定后举行一次模板制作大赛，几百元就可以弄几套不错的模板分享给大家&hellip;&hellip;毕竟菜鸟有很多</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('67','','','<div class=\"f14\" id=\"read_tpc\">\r\n	<span id=\"subject_tpc\">有很多商家是经常搞活动，搞促销的，如果给商家一个独立的页面，他就可以随时在上面更改信息，才能更好地把商家作为高级会员来发展，可以通过地图查找功能直接点击进入商家页面！</span></div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('68','','','<p>\r\n	手机网民超过电脑上网网民，P8的WAP在开发吗？<br />\r\n	WAP网民不可忽视，3G时代也离不开WAP2.0 啊！</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('69','','','<p>\r\n	哪有好的仿百度知道的问答系统啊,我公司想做一个问答版面,有谁知道啊</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('70','','','<div class=\"f14\" id=\"read_tpc\">\r\n	看过PHP168地方门户觉得很漂亮大气,自己想动手做一个,这个用付费吗?</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('71','','','<div class=\"f14\" id=\"read_tpc\">\r\n	请问php168是sql2005的数据库类型吗?还是什么5.0的数据库了,请知道的说下谢谢了!</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('72','','','<p>\r\n	<span id=\"subject_tpc\">建议开发一键更新发表文章时间的功能</span>，我晚上发的文章是不显示出来的，早上统一更新哦</p>\r\n','建议不错，官方已经收录了，等待评估。','146','1','admin','1282805296');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('73','','','<p>\r\n	问答系统里的积分有什么作用？要如何才能有积分？是需要回答别人的问题还是自己发布问题才能获得积分？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('74','','','<p>\r\n	<strong><span style=\"color: #ff0000\">求助：</span></strong><br />\r\n	这个提示其什么作用呢？请大家试一下，我试验的结果是：不论你选择&ldquo;确定&rdquo;还是&ldquo;取消&rdquo;按钮，都不能删除与之关联的数据，也就是相关附件！求官方给予正面解释其作用！<br />\r\n	<b><span style=\"color: #ff0000\">建议：</span></b><br />\r\n	应该在全站附件管理处给超级管理员增加一个&ldquo;一键清除全站冗余附件&rdquo;按钮。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('75','','','<p>\r\n	我想做一个专业的健康知识的问答网站，但是不知道如何推广，请各位大虾指点下。谢谢！</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('76','','','<div class=\"f14\" id=\"read_tpc\">\r\n	整站首页官方仅在文章rss标签栏目有&ldquo;更多&rdquo;按钮，在其他栏目没有&ldquo;更多&rdquo;按钮，且后台没有可以更改的选项。建议官方增加可以选择的 显示&ldquo;更多&rdquo; 开关。</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('77','','','<p>\r\n	V6.5的正式版包含了问答系统吗？是免费的吗？</p>\r\n<p>\r\n	我希望是免费的，呵呵。问答系统用途很大的。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('78','','','<div class=\"f14\" id=\"read_tpc\">\r\n	有协助我们把原来免费版数据顺利升级为授权版吗？<br />\r\n	还有提供多久的技术服务，程序如果升级，我们可以免费或者收费升级，还是重新购买呢?</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('79','','','<p>\r\n	如何把握电子商务发展中的致富机遇<br />\r\n	2012年，中国电子商务处于急速发展的井喷时期，随着越来越完善，脉络越来越喷张的物流，电子商务势必给传统生意模式带来前所未有的冲击。<br />\r\n	当渠道以及关系交易的模式，难以适应企业的发展，当客户面急剧下降，我们所有的企业不得不面对一个问题，那就是如何适应时代的变化及发展。<br />\r\n	当阿里巴巴在西部重地成都，开始大张旗鼓的建设他的第二分部，当慧聪网的付费会员一路飙升的超过了三万，当淘宝以999.6亿元交易额席卷亚洲，当创想商务打出个性建站、合理建站口号的时候，一个又一个的实事告诉我们，在经济危机之后，电子商务以波涛汹涌之势，一种的崭新的商业模式正在降临，在未来的几十年甚至更长的一段时间中，电子商务必将成为全球不可抗拒的商业模式。<br />\r\n	随着淘宝、拍拍等的不断发展，网上购物的群体已经逐步成为主流趋势，当60后、70后逐渐老去的时候，80后正在逐步掌握这个社会的主流，他们不同于祖辈，80后是随着电脑长大的一代，网购之势已然如同大江风帆，难以阻挡。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('80','','','<p>\r\n	RT，现在都是流行伪静态了，希望问答系统也能支持。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('81','','','<p>\r\n	我觉得问答系统已经很强大了，完全可以独立的建个问答方面的网站了。我想独立下载一套，不知道有免费下载的吗？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('82','','','<p>\r\n	现在只有6.5标准版或是分类新版再或是生活门户的出台会让我兴奋，希望上述几个系统快点有新的突破，个人关点，不知道有几个朋友和我有同样心情！</p>\r\n','144 今天发布正式版媒体版本，现在已经将6.5更名为PHP168SHARP版本，... 1282805117 1 admin','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('83','','','<div class=\"f14\" id=\"read_tpc\">\r\n	想做一个小型的<font color=\"red\">问答</font>系统！并且可以首页调用，一问一答就行，不知有没有哪位大侠可以帮小弟实现！谢谢！</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('84','','','<p>\r\n	现后台的操作日志可以全部删除，是不是也像PW后台那样保留必要的日志比如一月之内的不能删除，这样可以保留记录，不然网站后台被人进入之后一删除就什么记录也没了。特提出本建议。谢谢</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('85','','','<p>\r\n	请问官方问答系统是否支持ucenter，而且可以独立使用？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('87','','','<p>\r\n	建议P8的会员中心菜单设置中多加个显示或隐藏功能，加个允许哪些用户可以发表的内容</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('88','','','<p>\r\n	一般复制都是复制文本内容,包括标点符号，那么如果能把文本中的标点符号 自动替换成图片(预先做个小图片 这个图片内容就是这个相应的标点符号)还可以设置一些常用的汉字 也做成图片 自动替换文本中的相应的文字，这样别人在复制的时候&nbsp; 只能复制到文字 而这个图片 却复制不到。呵呵 估计他会郁闷很久....</p>','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('89','','','<div class=\"f14\" id=\"read_tpc\">\r\n	很期待的功能，不知道能实现吗？</div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('91','','','<p>\r\n	论坛里还没有高手做SHARP风格的吗？有的话先放出来给大家看看，也好做个借鉴。并且能放出个一步一步制作的教程最好。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('92','','','<p>\r\n	我想仿新浪的几个网页，保存后，用DW打开编辑乱七八糟的是怎么回事.是用DIV+CSS设计的网页<br />\r\n	但是在本地打开又是好好的。是怎么回事呢？如何让他恢复，在DW网页编辑器中让他有模有样 有规有律的。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('93','','','<p>\r\n	仿了个风格搜索页面不居中？怎么办啊？搜索页，跟搜索结果页都是占满屏，怎么居中啊？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('94','','','<p>\r\n	我都是按照教程一步一步来的，搞啦半天啦实在是不知道怎么弄啦，特来求助。这个是head index foot文件 额实在是不知道咋搞啦！拜托各位给小弟个思路呢。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('95','','','<p>\r\n	<span id=\"subject_tpc\">有什么好的地区门户网站麽？有的把地址贴出来</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('96','','','<p>\r\n	谁知道如何在网站后台添加 雅黑字体？也就是发表文章调用雅黑字体。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('97','','','<p>\r\n	导航下拉菜单不怎么好看，我想修改下，请问在哪个地方修改呢，我找了好长时间都没找到。各位大虾 帮帮忙了...</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('98','','','<p>\r\n	<span id=\"subject_tpc\">栏目和文章里面的其他设置中的滚动代码怎么改动</span>？还没有看到啊</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('99','','','<p>\r\n	为什么网站风格在百度快照里面变形了呢？在IE中测试了蛮好的啊</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('100','','','<p>\r\n	<span id=\"subject_tpc\">内容页模板在哪里设置啊？或者说在哪儿啊？高手指点一下。</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('101','','','<p>\r\n	有时大分类栏目太多了又不会分页，真是麻烦，但是小分类页的分类并不适用于大分类，请管理员说说看后台可设置，大争类超过多少栏目时分页，就像列表页可设置15条文章就分页一样。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('102','','','<p>\r\n	参考官方的演示站，商城图片的大小如何修改呢？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('104','','','<p>\r\n	将下载的文件上传到空间后，在后台怎么导入新安装的风格。要一个个修改模板的路径？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('105','','','<p>\r\n	哪位大侠能告诉我V6.01版本的更新缓存的具体位置在哪里，我每个栏目都仔细找过了，真没有找到</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('106','','','<p>\r\n	<span style=\"font-size: 14px\">在本地机测试正常，到了使用时失灵（点出后无反应），而其它如&ldquo;评论&quot;、&ldquo;收藏&rdquo;等均正常，请大家指点一二。</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('107','','','<p>\r\n	<span style=\"color: #0000cd\">请问高手，会员管理里面，如何查看会员的登录密码？现在显示的是加密码效果。</span><br />\r\n	&nbsp;</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('108','','','<p>\r\n	<span style=\"font-size: 14px\"><span>安装p8后，ICP备案号安装在哪个地方？有没有要求呢？</span></span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('109','','','<p>\r\n	<span style=\"font-size: 18px\">会员注册要通过审核在哪里设置了？请熟悉的高手出招了</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('110','','','<div class=\"f14\" id=\"read_tpc\">\r\n	<span style=\"color: #808080\">默认的&ldquo;评论&rdquo;如果设置为审核，就对所有会员都适用。能不能修改为，只针对普通会员才需要审核，而对管理员就不用审核了？各位高手请赐教。谢谢。</span></div>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('111','','','<p>\r\n	采集时把图片本地化提示图片格式不允许怎么办？&nbsp;明明都是jpg可有的就是不允许？什么原因啊？麻烦高手了</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('112','','','<p>\r\n	<span style=\"font-size: 18px\"><span style=\"color: #0000ff\">使用P8，如何更改怎样修改超级管理员账号名？请教各位大侠了！</span></span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('113','','','<p>\r\n	PHP168新平台将专注于实用领域，尽可能的服务于站长、媒体报刊、政府局级中高端应用，与之前的版本定位有所不同。很多用户包括斑竹强烈建议新架构采用一个全新的系列名称，以示区分。同时，老用户已经熟悉V6.X的相关应用，完全符合自身需求，强烈要求保持V6.x系列的一如既往的开发。官方有计划将V6.5的全新架构更名为S系列，sharp （锐利、锐不可挡之意）。特此向大家征集建议。</p>\r\n','76 考虑到诸多老用户无法适应新体系，为了照顾老用户，所以老体系即... 1282642266 3 shine','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('114','','','<p>\r\n	<span id=\"subject_tpc\">二次开发和插件区怎么要求这么高啊，积分100，建议降低一些了，我是新手啊</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('115','','','<p>\r\n	RT，知道系统的具体运用，怎样才能和网站完美结合？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('116','','','<p>\r\n	我以前用过快问的，最近想换个好用点的知道系统。要简单，实用。大家帮忙推荐一个</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('117','','','<p>\r\n	地方门户系统比较实用。用它建了一个地方站，想增加一个知道系统。不知道地方门户系统的后台里可以整合知道系统不？</p>\r\n<p>\r\n	<br />\r\n	&nbsp;</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('118','','','<p>\r\n	如果我购买授权后，自己安装不成功，官方可以免费帮我安装吗？</p>\r\n<p>\r\n	日后需要重装系统，是不是也免费的？呵呵<br />\r\n	&nbsp;</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('119','','','<p>\r\n	有知道系统的案例吗？发一个看看。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('120','','','<p>\r\n	问答系统里如何向专家提问？是不是只要是会员都可以向专家提问？专家是直接给我回答吗？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('122','','','<p>\r\n	我想建个医学站，有没有人帮做模板？<span bookmark=\"1\" style=\"display: none\">&nbsp;难度邮递</span></p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('123','','','<p>\r\n	测试一下，哈哈哈哈</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('124','','','<p>\r\n	这个版本感觉不错，不知道什么时间发布啊。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('125','','','<p>\r\n	很期待使用问答系统，官方介绍下</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('126','','','<p>\r\n	6.5系统怎么忽然改为Sharp系列了？</p>\r\n<p>\r\n	不过Sharp名字还不错。</p>\r\n','139 PHP168新平台将专注于实用和高负载领域，尽可能的服务于站长、媒... 1282796528 0','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('127','','','<p>\r\n	今天6.5正式版发布，大概是什么时候？</p>\r\n<p>\r\n	呵呵，是下班前吧。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('128','','','<p>\r\n	&nbsp;有协助我们把原来免费版数据顺利升级为授权版吗？<br />\r\n	<br />\r\n	还有提供多久的技术服务，程序如果升级，我们可以免费或者收费升级，还是重新购买呢?</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('129','','','<p>\r\n	论坛里还没有高手做SHARP风格的吗？有的话先放出来给大家看看，也好做个借鉴。并且能放出个一步一步制作的教程最好。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('130','','','<p>\r\n	RT，我在论坛找了好久没有找到。呵呵</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('131','','','<p>\r\n	V6.5整站套件安装过程中出现数据库连接错误，是不是我的数据库资料填写错误了？<br />\r\n	&nbsp;</p>\r\n<p>\r\n	<br />\r\n	数据库名是不是可以任意填写？</p>','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('132','','','<p>\r\n	看过PHP168地方门户觉得很漂亮大气,自己想动手做一个,这个用付费吗?</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('133','','','<p>\r\n	怎么设置前台权限？</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('134','','','<p>\r\n	额外热贪玩儿而问题沃尔特认为tertiary热熔他</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('135','','','<p>\r\n	提问，如何提问，看看就知道了</p>\r\n','很好，新年好','148','2','cqifeng','1297647074');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('136','','','<p>\r\n	之前有个供应商的发票给我，放在柜子里面太久，过期了</p>\r\n<p>\r\n	怎么处理这个</p>\r\n','没的办法处理的。\r\n\r\n只能退给供应商，让供应商去税务局退票','149','2','cqifeng','1297647767');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('139','','','<p>\r\n	sdfsdfsdfsdfsdfsdfsdfsdfsdf</p>\r\n','是的发生的的是否发生的','151','2','cqifeng','1297822277');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('144','','','<p>\r\n	你好，我要如何购买系统</p>\r\n','找客服就可以了','153','2','cqifeng','1297836121');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('145','','','<p>\r\n	sdfsdfsdfsdfasdfasdfsdf</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('218','','','<p>\r\n	sdf sdfsdafsdfsdfdsafsdfsdfsdfdsf</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('221','','','<p>\r\n	如题。</p>\r\n','','0','0','','0');
REPLACE INTO `p8_ask_item_data` (`id`,`tel`,`info`,`content`,`bestanswer`,`bestanswer_id`,`bestanswer_uid`,`bestanswer_username`,`bestanswer_time`)VALUES('226','','','地方过放电 梵蒂冈&nbsp; 发的 ','','0','0','','0');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页一张图片','image','a:7:{s:5:\"width\";s:3:\"124\";s:6:\"height\";s:3:\"107\";s:5:\"image\";a:3:{s:5:\"title\";s:0:\"\";s:3:\"url\";s:0:\"\";s:4:\"name\";s:64:\"<!--#p8_attach#-->/core/label/2010_12/13_13/f0ab5949b447a450.jpg\";}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页一张图片]','0','1409245329','1516089539','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容中一','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:14:\"ask/item/list2\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";s:7:\"9,8,7,5\";s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:9:\"recommend\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"28\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容中一]','0','1409245329','1516089539','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容中三','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:21:\"ask/item/list_status2\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:7:\"unsolve\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"36\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:853:\"<!--{php168}-->\r\n<table class=\"label_ul_s label_table\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"  border=\"0\">\r\n<tr class=\"label_tr_head\">\r\n		<td width=\"65%\" >提问标题</td>\r\n		<td width=\"10%\" >状态</td>\r\n		<td width=\"10%\" >咨询人</td>\r\n		<td width=\"10%\" >时间</td>\r\n	</tr>\r\n	<!--{foreach $list $value}-->\r\n	<tr >\r\n		<td>·<a href=\"$value[url]\" target=\"_blank\" title=\"$value[full_title]\" style=\"color:#00f; text-decoration:underline; font-size:12px\">$value[title]</a><span style=\"color:#999999\">[<a href=\"$value[category_url]\" target=\"_blank\" style=\"color:#999999\">{$value[\'category_name\']}</a>]</span> </td>\r\n		<td><img align=\"middle\" src=\"$RESOURCE/skin/label/status_{if $value[\'status\']==3 }5{else}4{/if}.gif\" /></td>\r\n		<td> $value[username]</td>\r\n		<td>{date(\'m/d\',$value[\'addtime\'])}</td>\r\n	</tr>\r\n	<!--{/foreach}-->\r\n</table>\r\n<!--{/php168}-->\r\n\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容中三]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容中五','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:21:\"ask/item/list_status3\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:9:\"recommend\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"30\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:855:\"<!--{php168}-->\r\n<table class=\"label_ul_s label_table\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"  border=\"0\">\r\n<tr class=\"label_tr_head\">\r\n		<td width=\"65%\" >提问标题</td>\r\n		<td width=\"10%\" >状态</td>\r\n		<td width=\"10%\" >咨询人</td>\r\n		<td width=\"10%\" >时间</td>\r\n	</tr>\r\n	<!--{foreach $list $value}-->\r\n	<tr >\r\n		<td>·<a href=\"$value[url]\" target=\"_blank\" title=\"$value[full_title]\" style=\"color:#00f; text-decoration:underline; font-size:12px\">$value[title]</a><span style=\"color:#999999\">[<a href=\"$value[category_url]\" target=\"_blank\" style=\"color:#999999\">{$value[\'category_name\']}</a>]</span> </td>\r\n		<td><img align=\"middle\" src=\"$RESOURCE/skin/label/status_{if $value[\'recommend\']==1}6{else}4{/if}.gif\" /></td>\r\n		<td> $value[username]</td>\r\n		<td>{date(\'m/d\',$value[\'addtime\'])}</td>\r\n	</tr>\r\n	<!--{/foreach}-->\r\n</table>\r\n<!--{/php168}-->\r\n\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容中五]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容中四','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:21:\"ask/item/list_status2\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:5:\"solve\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"30\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:853:\"<!--{php168}-->\r\n<table class=\"label_ul_s label_table\" width=\"100%\" cellpadding=\"3\" cellspacing=\"0\"  border=\"0\">\r\n<tr class=\"label_tr_head\">\r\n		<td width=\"65%\" >提问标题</td>\r\n		<td width=\"10%\" >状态</td>\r\n		<td width=\"10%\" >咨询人</td>\r\n		<td width=\"10%\" >时间</td>\r\n	</tr>\r\n	<!--{foreach $list $value}-->\r\n	<tr >\r\n		<td>·<a href=\"$value[url]\" target=\"_blank\" title=\"$value[full_title]\" style=\"color:#00f; text-decoration:underline; font-size:12px\">$value[title]</a><span style=\"color:#999999\">[<a href=\"$value[category_url]\" target=\"_blank\" style=\"color:#999999\">{$value[\'category_name\']}</a>]</span> </td>\r\n		<td><img align=\"middle\" src=\"$RESOURCE/skin/label/status_{if $value[\'status\']==3 }5{else}4{/if}.gif\" /></td>\r\n		<td> $value[username]</td>\r\n		<td>{date(\'m/d\',$value[\'addtime\'])}</td>\r\n	</tr>\r\n	<!--{/foreach}-->\r\n</table>\r\n<!--{/php168}-->\r\n\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容中四]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','member','问答首页内容右三标一','module_data','a:21:{s:8:\"order_by\";a:1:{s:12:\"i.item_count\";s:1:\"1\";}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:34:\"ask/member/category_side_expertors\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:6:\"mbtype\";s:1:\"0\";s:8:\"category\";a:0:{}s:13:\"order_by_desc\";a:1:{i:0;s:1:\"1\";}s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"20\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:6:\"&#160;\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:15:\"order_by_string\";s:17:\"i.item_count DESC\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右三标一]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','member','问答首页内容右三标二','module_data','a:21:{s:8:\"order_by\";a:1:{s:13:\"i.reply_count\";s:1:\"1\";}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:34:\"ask/member/category_side_expertors\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:6:\"mbtype\";s:1:\"0\";s:8:\"category\";a:0:{}s:13:\"order_by_desc\";a:1:{i:0;s:1:\"1\";}s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"20\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:6:\"&#160;\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:15:\"order_by_string\";s:18:\"i.reply_count DESC\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右三标二]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','member','问答首页内容右二','module_data','a:18:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"4\";s:8:\"template\";s:28:\"ask/member/expertor_ask_mine\";s:13:\"unset_options\";a:0:{}s:6:\"mbtype\";s:6:\"expert\";s:8:\"category\";s:9:\"9,8,7,6,5\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"25\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:2:\"20\";s:7:\"tplcode\";s:6:\"&nbsp;\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右二]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','cms','item','问答首页内容右四','module_data','a:28:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"6\";s:8:\"template\";s:26:\"common/ico_title/list012-2\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:1:{i:0;s:3:\"445\";}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:1:\"0\";s:6:\"sphinx\";s:1:\"0\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"rows\";s:1:\"1\";s:16:\"top_title_length\";s:2:\"40\";s:12:\"title_length\";s:2:\"30\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:343:\"<!--{php168}-->\r\n<ul class=\"label_ul_s\">\r\n<!--{foreach $list $value}-->\r\n	<li style=\"$wf;\">\r\n		<span class=\"label_datatime\" style=\"color:#\">{date(\'m-d\', $value[\'timestamp\'])}</span>·<a href=\"$value[url]\" target=\"_blank\" title=\"$value[full_title]\">$value[title]</a>\r\n	</li>\r\n<!--{/foreach}-->\r\n	<li class=\"clear\"></li>\r\n</ul>\r\n<!--{/php168}-->\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:5:\"model\";s:0:\"\";s:4:\"uids\";s:0:\"\";s:9:\"timestamp\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";s:7:\"exclude\";s:0:\"\";}s:6:\"field#\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右四]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容左一','module_data','a:21:{s:8:\"order_by\";a:1:{s:7:\"i.views\";s:1:\"1\";}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"4\";s:8:\"template\";s:24:\"common/ico_title/list022\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:0:\"\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"24\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:15:\"order_by_string\";s:12:\"i.views DESC\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容左一]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容左三','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"6\";s:8:\"template\";s:24:\"common/ico_title/list002\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:5:\"topic\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"24\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容左三]','0','1409245329','1516089539','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容左二','module_data','a:21:{s:8:\"order_by\";a:1:{s:4:\"i.id\";s:1:\"0\";}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"4\";s:8:\"template\";s:24:\"common/ico_title/list002\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:0:\"\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"22\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:15:\"order_by_string\";s:8:\"i.id ASC\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容左二]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页底部广告','image','a:7:{s:5:\"width\";s:3:\"990\";s:6:\"height\";s:2:\"56\";s:5:\"image\";a:3:{s:5:\"title\";s:0:\"\";s:3:\"url\";s:0:\"\";s:4:\"name\";s:64:\"<!--#p8_attach#-->/core/label/2013_01/04_10/8d0680f1209088bc.jpg\";}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页底部广告]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多中一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp;更多 >>','$label[问答首页更多中一]','0','1409245329','1516089539','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多中三','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp;更多>>','$label[问答首页更多中三]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多中二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','<a href=\"\">更多>></a>','$label[问答首页更多中二]','0','1409245367','1516089539','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多中五','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp; 更多>>','$label[问答首页更多中五]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多中四','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp; 更多>>','$label[问答首页更多中四]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题中一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp;推荐问题','$label[问答首页标题中一]','0','1409245367','1516089539','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题中三','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}',' 待解决问题','$label[问答首页标题中三]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题中二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}',' 专家预告','$label[问答首页标题中二]','0','1409245367','1516089539','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题中五','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&#160;知识归类','$label[问答首页标题中五]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题中四','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}',' 已解决问题','$label[问答首页标题中四]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&nbsp;问答资讯','$label[问答首页标题右一]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右三标一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','问题排行','$label[问答首页标题右三标一]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右三标二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','回答排行','$label[问答首页标题右三标二]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','专家/主管','$label[问答首页标题右二]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右五','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"37\";s:19:\"place_holder_height\";s:2:\"36\";}','问答事项','$label[问答首页标题右五]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右四','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','问答整改','$label[问答首页标题右四]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题左一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','热点问答','$label[问答首页标题左一]','0','1409245367','1516545807','300','','1409245367','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题左三','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&#160;最热问题','$label[问答首页标题左三]','0','1409245329','1516089539','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题左二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"151\";s:19:\"place_holder_height\";s:2:\"33\";}','&#160;最新问答','$label[问答首页标题左二]','0','1409245329','1516545807','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','ask_search_text','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','<a  href=\"#\">政府常见问题解答平台！！<br />\r\n<a  href=\"#\">大家一起加入</a> ','$label[ask_search_text]','0','1409245528','1516545807','300','index','1409245528','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','gov80-indexBanner','slide','a:8:{s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"500\";s:8:\"template\";s:20:\"cms/slide/gov_slide7\";s:6:\"images\";a:3:{s:5:\"title\";a:1:{i:0;s:0:\"\";}s:3:\"url\";a:1:{i:0;s:0:\"\";}s:3:\"src\";a:1:{i:0;s:64:\"<!--#p8_attach#-->/core/label/2016_03/05_15/9639cc6396a00437.jpg\";}}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[gov80-indexBanner]','0','1463614042','1516545807','300','index','1463614042','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','ask','item','问答首页内容中二','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"4\";s:8:\"template\";s:18:\"ask/item/li_number\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";s:1:\"9\";s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:0:\"\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"40\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容中二]','0','1409245435','1516089539','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','cms','item','问答首页内容右一','module_data','a:28:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"6\";s:8:\"template\";s:26:\"common/ico_title/dot_title\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:0:{}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:1:\"0\";s:6:\"sphinx\";s:1:\"0\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"rows\";s:1:\"1\";s:16:\"top_title_length\";s:2:\"40\";s:12:\"title_length\";s:2:\"22\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:5:\"model\";s:0:\"\";s:4:\"uids\";s:0:\"\";s:9:\"timestamp\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";s:7:\"exclude\";s:0:\"\";}s:6:\"field#\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右一]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','cms','item','问答首页内容右五','module_data','a:28:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:24:\"common/ico_title/list001\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:1:{i:0;s:3:\"446\";}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:1:\"0\";s:6:\"sphinx\";s:1:\"0\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"rows\";s:1:\"1\";s:16:\"top_title_length\";s:2:\"40\";s:12:\"title_length\";s:2:\"22\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:5:\"model\";s:0:\"\";s:4:\"uids\";s:0:\"\";s:9:\"timestamp\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";s:7:\"exclude\";s:0:\"\";}s:6:\"field#\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右五]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','cms','item','问答首页内容右六','module_data','a:28:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:1:\"4\";s:8:\"template\";s:24:\"common/ico_title/list001\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:0:{}s:8:\"category\";a:1:{i:0;s:3:\"225\";}s:7:\"keyword\";s:0:\"\";s:9:\"attribute\";s:1:\"0\";s:6:\"sphinx\";s:1:\"0\";s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"300\";s:4:\"rows\";s:1:\"1\";s:16:\"top_title_length\";s:2:\"40\";s:12:\"title_length\";s:2:\"26\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:0:{}s:5:\"model\";s:0:\"\";s:4:\"uids\";s:0:\"\";s:9:\"timestamp\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";s:7:\"exclude\";s:0:\"\";}s:6:\"field#\";a:0:{}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答首页内容右六]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页广告1','image','a:7:{s:5:\"width\";s:3:\"238\";s:6:\"height\";s:2:\"79\";s:5:\"image\";a:3:{s:5:\"title\";s:0:\"\";s:3:\"url\";s:22:\"index.php/ask/item-ask\";s:4:\"name\";s:64:\"<!--#p8_attach#-->/core/label/2013_01/04_10/9b613bc7cf248577.jpg\";}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[问答首页广告1]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页广告2','image','a:7:{s:5:\"width\";s:3:\"238\";s:6:\"height\";s:2:\"75\";s:5:\"image\";a:3:{s:5:\"title\";s:0:\"\";s:3:\"url\";s:0:\"\";s:4:\"name\";s:64:\"<!--#p8_attach#-->/core/label/2013_01/04_10/44a5563670703ad3.jpg\";}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[问答首页广告2]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多右一','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','<a href=\"{$core.U_controller}/cms/item-add?model=article&cid=444\" target=\"_blank\">发布>></a>','$label[问答首页更多右一]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多右二','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[问答首页更多右二]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多右五','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&#160;&#160;<a href=\"{$core.U_controller}/cms/item-add?model=article&cid=446\" target=\"_blank\">发布>></a>','$label[问答首页更多右五]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多右六','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&#160;&#160;<a href=\"{$core.U_controller}/cms/item-add?model=article&cid=225\" target=\"_blank\">发布>></a>','$label[问答首页更多右六]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页更多右四','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','&#160;<a href=\"{$core.U_controller}/cms/item-add?model=article&cid=445\" target=\"_blank\">发布>></a>','$label[问答首页更多右四]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页标题右六','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"18\";s:19:\"place_holder_height\";s:2:\"48\";}','企业资讯','$label[问答首页标题右六]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页首页广告567','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[问答首页首页广告567]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','','','','','','问答首页首页广告78','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[问答首页首页广告78]','0','1409245435','1516545807','300','index','1409245435','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','item','','','','','gov80-indexBanner','slide','a:8:{s:5:\"width\";s:4:\"100%\";s:6:\"height\";s:3:\"500\";s:8:\"template\";s:20:\"cms/slide/gov_slide7\";s:6:\"images\";a:3:{s:5:\"title\";a:1:{i:0;s:0:\"\";}s:3:\"url\";a:1:{i:0;s:0:\"\";}s:3:\"src\";a:1:{i:0;s:64:\"<!--#p8_attach#-->/core/label/2016_03/05_15/9639cc6396a00437.jpg\";}}s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','','$label[gov80-indexBanner]','0','1463614142','1516546634','300','','1463614142','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','item','','','ask','item','问答内页右一内容','module_data','a:20:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:20:\"ask/item/list_status\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:1:{i:0;s:7:\"keyword\";}s:8:\"category\";a:0:{}s:7:\"keyword\";s:8:\"$KEYWORD\";s:9:\"attribute\";s:0:\"\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"24\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:1:{s:7:\"i.title\";a:2:{s:8:\"operator\";s:6:\"search\";s:3:\"var\";s:8:\"$KEYWORD\";}}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答内页右一内容]{&#039;i.title&#039; =&gt; $KEYWORD}','1','1409245329','1498855381','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','item','','','','','问答内页右一标题','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','相关问题','$label[问答内页右一标题]','0','1409245329','1516091237','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','item','','','ask','member','问答内页右二内容','module_data','a:19:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:26:\"ask/member/expertor_ask_my\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:1:{i:0;s:8:\"category\";}s:6:\"mbtype\";s:6:\"expert\";s:8:\"category\";s:9:\"$CATEGORY\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"20\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:2:\"30\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:1:{s:5:\"E.cid\";a:2:{s:8:\"operator\";s:2:\"in\";s:3:\"var\";s:9:\"$CATEGORY\";}}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答内页右二内容]{&#039;E.cid&#039; =&gt; $CATEGORY}','1','1409245329','1498855381','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','item','','','','','问答内页右二标题','html','a:4:{s:7:\"bgcolor\";s:0:\"\";s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:2:\"60\";s:19:\"place_holder_height\";s:2:\"20\";}','本栏目专家','$label[问答内页右二标题]','0','1409245329','1516091237','300','','1409245329','');
INSERT INTO `p8_label` (`system`,`module`,`site`,`env`,`source_system`,`source_module`,`name`,`type`,`option`,`content`,`invoke`,`variable`,`timestamp`,`last_update`,`ttl`,`postfix`,`update_time`,`last_setter`)VALUES('ask','member','','','ask','member','问答内页右二内容','module_data','a:19:{s:8:\"order_by\";a:0:{}s:8:\"pageable\";s:1:\"0\";s:3:\"ids\";s:0:\"\";s:5:\"limit\";s:2:\"10\";s:8:\"template\";s:26:\"ask/member/expertor_ask_my\";s:6:\"method\";s:5:\"label\";s:13:\"unset_options\";a:1:{i:0;s:8:\"category\";}s:6:\"mbtype\";s:6:\"expert\";s:8:\"category\";s:9:\"$CATEGORY\";s:6:\"sphinx\";a:0:{}s:12:\"title_length\";s:2:\"20\";s:9:\"title_dot\";s:1:\"0\";s:14:\"summary_length\";s:3:\"120\";s:7:\"tplcode\";s:0:\"\";s:7:\"bgcolor\";s:0:\"\";s:10:\"var_fields\";a:1:{s:5:\"E.cid\";a:2:{s:8:\"operator\";s:2:\"in\";s:3:\"var\";s:9:\"$CATEGORY\";}}s:13:\"allowed_roles\";a:0:{}s:18:\"place_holder_width\";s:3:\"100\";s:19:\"place_holder_height\";s:2:\"30\";}','','$label[问答内页右二内容]{&#039;E.cid&#039; =&gt; $CATEGORY}','1','1409245329','0','300','','1409245329','');
REPLACE INTO `p8_config` (`system`,`module`,`type`,`k`,`v`)VALUES('ask','','serialize','admin_actions_map','a:3:{s:6:\"config\";s:12:\"模块配置\";s:10:\"statistics\";s:12:\"统计信息\";s:9:\"cache_all\";s:12:\"更新缓存\";}');
REPLACE INTO `p8_config` (`system`,`module`,`type`,`k`,`v`)VALUES('ask','','string','table_prefix','');
